#include <stdio.h>

/* We'll be using MPI routines, definitions, etc. */
#include "mpi.h"


main(int argc, char** argv) {
   
   int my_rank;     /* Rank of process */
   int p;           /* Number of processes */
   int namelen;    /* Length of processor name */
   char processor_name[MPI_MAX_PROCESSOR_NAME];

    /* Let the system do what it needs to start up MPI */
    MPI_Init(&argc, &argv);

    /* Get my process rank */
    MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);

    /* Find out how many procesors are being used */
    MPI_Comm_size(MPI_COMM_WORLD, &p);
   
    /* Get the name of the processor */
    MPI_Get_processor_name(processor_name, &namelen);


    printf("Greetings from process %d! from %s \n", 
    my_rank, processor_name);
    

  /* Shut down MPI */
  MPI_Finalize();
} /*  main  */
